//
//  LTPKObject.m
//
//  Created by admin code=123 on 10-4-26.
//  Copyright 2010 __LogicalTech__. All rights reserved.
//

#import "LTPKObject.h"
#include "ltpkapi.h"

//#pragma warning(
void ConvertStringToGUID(const char *strProductID, GUID *guid)
{
	sscanf(strProductID, "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x",
		   &guid->Data1, &guid->Data2, &guid->Data3, &guid->Data4[0], &guid->Data4[1],&guid->Data4[2],
		   &guid->Data4[3],&guid->Data4[4],&guid->Data4[5],&guid->Data4[6],&guid->Data4[7]);
	
}

@implementation LTPKObject
- (IBAction)LTReadKey:(id)sender {	
	NSString *strProductID = [aProductIDField stringValue];
	GUID pid;
	const char *pszID = [strProductID UTF8String];
	ConvertStringToGUID(pszID, &pid);
	
	NSString *strPassword = [aReadPassword stringValue];
    unsigned char byData[64];
	
	unsigned int uPassword = 0;
	const char *pszPassword = [strPassword UTF8String];	
	sscanf(pszPassword, "%x", &uPassword);
	
	BOOL result = SKAPIGetUserData(&pid, uPassword, byData);
	NSString *strInfo;
	if(result)
		strInfo = @"Read PK Data Success!";
	else
		strInfo = @"Read PK Data Failed!";
	
	NSAlert *alert = [NSAlert alertWithMessageText:nil
									 defaultButton:@"OK"
								   alternateButton:nil
									   otherButton:nil
						informativeTextWithFormat:strInfo
					  ];
	[alert runModal];
}

- (IBAction)LTWriteKey:(id)sender {
	NSString *strProductID = [aProductIDField stringValue];
	GUID pid;
	const char *pszID = [strProductID UTF8String];
	ConvertStringToGUID(pszID, &pid);
	
	NSString *strPassword = [aWritePassword stringValue];
    unsigned char byData[64];
	for(int i = 0; i<64; i++)
	{
		byData[i] = i;		
	}
	
	unsigned int uPassword = 0;
	const char *pszPassword = [strPassword UTF8String];	
	sscanf(pszPassword, "%x", &uPassword);
	
	BOOL result = SKAPISetUserData(&pid, uPassword, byData);
	NSString *strInfo;
	if(result)
		strInfo = @"Write PK Data Success!";
	else
		strInfo = @"Write PK Data Failed!";
	
	NSAlert *alert = [NSAlert alertWithMessageText:nil
									 defaultButton:@"OK"
								   alternateButton:nil
									   otherButton:nil
						 informativeTextWithFormat:strInfo
					  ];
	[alert runModal];
}

- (IBAction)LTGenRandom:(id)sender{
	NSString *strProductID = [aProductIDField stringValue];
	GUID pid;
	const char *pszID = [strProductID cStringUsingEncoding:NSASCIIStringEncoding];
	ConvertStringToGUID(pszID, &pid);
	
	NSString *strPassword = [aReadPassword stringValue];
   
	
	unsigned int uPassword = 0;
	const char *pszPassword = [strPassword  cStringUsingEncoding:NSASCIIStringEncoding];	
	sscanf(pszPassword, "%x", &uPassword);
	
	NSString *strRandom = [aRandom stringValue];
	NSData *byRandom = [strRandom dataUsingEncoding:NSASCIIStringEncoding];
	
	unsigned char byData[16];
	unsigned int len = 16;
	memset(byData, 0, len);
	memcpy(byData, [byRandom bytes], [byRandom length] > 16 ? 16 : [byRandom length]);
	BOOL result = PKAPIGenRandom(&pid, uPassword, byData, len);
	NSString *strInfo;
	if(result)
	{
		strInfo = @"Genrate Random Data Success!";
	}
	else
		strInfo = @"Genrate Random Data Failed!";
	
	NSAlert *alert = [NSAlert alertWithMessageText:nil
									 defaultButton:@"OK"
								   alternateButton:nil
									   otherButton:nil
						 informativeTextWithFormat:strInfo
					  ];
	[alert runModal];
}

- (IBAction)LTCalcSha1:(id)sender {
	NSString *strProductID = [aProductIDField stringValue];
	GUID pid;
	const char *pszID = [strProductID UTF8String];
	ConvertStringToGUID(pszID, &pid);
	
	NSString *strPassword = [aReadPassword stringValue];	
	unsigned int uPassword = 0;
	const char *pszPassword = [strPassword UTF8String];	
	sscanf(pszPassword, "%x", &uPassword);
	
	NSString *strRandom = [aRandom stringValue];
	NSData *byRandom = [strRandom dataUsingEncoding:NSASCIIStringEncoding];
	unsigned char byHardDigest[20];
	BOOL result = PKAPISHA1HashbyHard(&pid, uPassword, [byRandom bytes], [byRandom length], byHardDigest);
	NSString *strInfo;
	if(result)
	{
		unsigned char bySoftDigest[20];
		NSString *strSecretKey = [aSecretKey stringValue];
		NSData *bySecretKey = [strSecretKey dataUsingEncoding:NSASCIIStringEncoding]; 
		result = PKAPISHA1HashbySoft(&pid, uPassword, [byRandom bytes], [byRandom length],
									[bySecretKey bytes], [bySecretKey length], bySoftDigest);
		if(result)
		{
			int i = 0;
			for(i; i<20; i++)
			{
				if(byHardDigest[i] != bySoftDigest[i])
					break;
			}
			if(i == 20)
			{
				strInfo = @"Sha1 is equal!";
			}
			else
			{
				strInfo = @"Sha1 is not equal!";
			}

		}
		else {
			strInfo = @"Software Calc Sha1 Failed!";
		}
	}
	else
		strInfo = @"Hardware Calc Sha1 Failed!";
	
	NSAlert *alert = [NSAlert alertWithMessageText:nil
									 defaultButton:@"OK"
								   alternateButton:nil
									   otherButton:nil
						 informativeTextWithFormat:strInfo
					  ];
	[alert runModal];
}


@end
