#ifndef __LTPKAPI_H__
#define __LTPKAPI_H__

#include <Carbon/Carbon.h>

typedef struct _GUID {
    unsigned int  Data1;
    unsigned short Data2;
    unsigned short Data3;
    unsigned char  Data4[ 8 ];
} GUID;

// Get User Data by Develop GUID;
BOOL  SKAPIGetUserData(const GUID* pidDevelop,
							 unsigned int uReadPassword,
							 unsigned char* pbyData
							 );
// Set User Data by Develop GUID;
BOOL  SKAPISetUserData(const GUID* pidDevelop,
							 unsigned int uWritePassword,
							 const unsigned char* pbyData
							 );
//Hardware perform sha1 hash
BOOL  PKAPISHA1HashbyHard(const GUID* pidDevelop,
									 unsigned int uReadPassword,
									 const unsigned char* pucData,
									 unsigned int ulLength,
									 unsigned char* pucDigest
									 );
//software perform sha1 hash
BOOL  PKAPISHA1HashbySoft(const GUID* pidDevelop,
								unsigned int uReadPassword,
								const unsigned char* pucData,
								unsigned int ulLength,
								const unsigned char* pucKey, 
								unsigned int ulKeyLength,
								unsigned char* pucDigest
								);
//Hardware generate 16 bytes random
BOOL  PKAPIGenRandom(const GUID* pidDevelop,
							unsigned int uReadPassword,
							unsigned char* pucBuffer,
							uint32_t ulBufferSize
							);
#endif	// __LTPKAPI_H__
