#ifndef __SKAPI_H__
#define __SKAPI_H__


typedef struct
{
	GUID	guidDevelop;
	DWORD	dwReadPassword;
	DWORD	dwWritePassword;
	BYTE	byEncryptKey[16];
	DWORD   dwValidateOption;
// Can't support konic api -------
	DWORD	dwStartDate;
	DWORD	dwEndDate;
//--------------------------------
} SKCONTROLDATA, *PSKCONTROLDATA;

typedef BOOL (WINAPI *ENUMDEVICEPROC)(GUID* pidDevice, DWORD dwParam);


#define SKAPI_ALGORITHM_IDEA		1
#define SKAPI_ALGORITHM_HARDWARE	10


#ifdef __cplusplus
extern "C" {
#endif

BOOL WINAPI SKAPIInitialize();
void WINAPI SKAPIClose();
BOOL WINAPI SKAPIChangeAdminPassword(const GUID* pidDevice, const BYTE* pbyOld, const BYTE* pbyNew);
BOOL WINAPI SKAPIGetControlData(const GUID* pidDevice, const BYTE* pbyPassword, SKCONTROLDATA* pcd);
BOOL WINAPI SKAPISetControlData(const GUID* pidDevice, const BYTE* pbyPassword, const SKCONTROLDATA* pcd);
BOOL WINAPI SKAPIEnumDevices(ENUMDEVICEPROC lpEnumProc, DWORD dwParam);
BOOL WINAPI SKAPIGetUserData(const GUID* pidDevelop, const DWORD dwReadPassword, BYTE* pbyData);
BOOL WINAPI SKAPISetUserData(const GUID* pidDevelop, const DWORD dwWritePassword, const BYTE* pbyData);

BOOL WINAPI SKAPIInitEncryptKey(const UINT nAlgorithm, const GUID* pidDevelop, const BYTE* byKey);
BOOL WINAPI SKAPIEncrypt(BYTE* byData);
BOOL WINAPI SKAPIDecrypt(BYTE* byData);

#ifdef __cplusplus
}
#endif

#endif	// __SKAPI_H__