// SKToolsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SKTools.h"
#include "SKToolsDlg.h"
#include "skapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSKToolsDlg dialog

CSKToolsDlg::CSKToolsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSKToolsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSKToolsDlg)
	m_strSrcFile = _T("");
	m_strDesFile = _T("");
	m_strDevelop = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSKToolsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSKToolsDlg)
	DDX_Text(pDX, IDC_EDITSRCFILE, m_strSrcFile);
	DDV_MaxChars(pDX, m_strSrcFile, 256);
	DDX_Text(pDX, IDC_EDITDESFILE, m_strDesFile);
	DDV_MaxChars(pDX, m_strDesFile, 256);
	DDX_Text(pDX, IDC_DEVELOPID, m_strDevelop);
	DDV_MaxChars(pDX, m_strDevelop, 38);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSKToolsDlg, CDialog)
	//{{AFX_MSG_MAP(CSKToolsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(EN_SETFOCUS, IDC_EDITSRCFILE, IDC_RADIODECRYPT, OnControlSetFocus)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSKToolsDlg message handlers

BOOL CSKToolsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	// In dialog, this will show bitmap center.

	SendDlgItemMessage(IDC_RADIOENCRYPT, BM_SETCHECK, BST_CHECKED, 0);

	nLastControl = IDC_EDITSRCFILE;

	hhook = SetWindowsHookEx(WH_KEYBOARD, KeyboardProc, NULL, GetCurrentThreadId());
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSKToolsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSKToolsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

#pragma optimize( "", off )
void CSKToolsDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	UpdateData(TRUE);

	DWORD dwStart = GetTickCount();
	if(SKAPIInitialize())
	{
		DWORD f1;
		GUID guid;
		DWORD h2;
		
		sscanf(m_strDevelop, "{%lx%-%hx%-%hx%-%02x%02x%-%02x%02x%02x%02x%02x%02x}", 
				&guid.Data1, &guid.Data2, &guid.Data3, 
				&guid.Data4[0], &guid.Data4[1], &guid.Data4[2], &guid.Data4[3],
				&guid.Data4[4], &guid.Data4[5], &guid.Data4[6], &guid.Data4[7]);

		UNREFERENCED_PARAMETER(f1);
		UNREFERENCED_PARAMETER(h2);

		// Init Encrypt Key
		if(!SKAPIInitEncryptKey(SKAPI_ALGORITHM_IDEA, &guid, NULL))
		{
			AfxMessageBox(IDS_LOCKFAILED);
			SKAPIClose();
			return;
		}

		if(SendDlgItemMessage(IDC_RADIOENCRYPT, BM_GETCHECK, 0, 0) == BST_CHECKED)
		{
			// Encrypt data;
			BYTE byData[8];
			int iLen;
			BYTE *pText;
			DWORD dwBytes;
			HANDLE hFile = CreateFile(m_strSrcFile, GENERIC_READ,
						FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
			if(hFile == INVALID_HANDLE_VALUE)
			{
				AfxMessageBox(IDS_OPENFILE);
				SKAPIClose();
				return;
			}
			DWORD dwOriginalSize = GetFileSize(hFile, NULL);
			BYTE* pBuffer = new BYTE[dwOriginalSize+8];
			if(!ReadFile(hFile, pBuffer, dwOriginalSize, &dwBytes, NULL)
						|| dwBytes == 0)
			{
				AfxMessageBox(IDS_LOCKFAILED);
				SKAPIClose();
				delete pBuffer;
				CloseHandle(hFile);
				return;
			}
			CloseHandle(hFile);

			iLen = dwOriginalSize+8;
			UINT a,i;
			a = iLen/8;

			hFile = CreateFile(m_strDesFile, GENERIC_WRITE,
						0, NULL, CREATE_ALWAYS, 0, NULL);
			if(hFile == INVALID_HANDLE_VALUE)
			{
				AfxMessageBox(IDS_WRITEFILE);
				SKAPIClose();
				delete pBuffer;
				return;
			}
			pText = pBuffer;
			int iWriteLen = 0;
			WriteFile(hFile, &dwOriginalSize, 4, &dwBytes, NULL);
			for(i=0; i<a; i++)
			{
				memset(byData, 0, 8);
				memcpy((LPSTR)byData, pText, 8);
				if(!SKAPIEncrypt(byData))
				{
					AfxMessageBox(IDS_LOCKFAILED);
					SKAPIClose();
					delete pBuffer;
					CloseHandle(hFile);
					return;
				}
				WriteFile(hFile, byData, 8, &dwBytes, NULL);
				pText +=8;
			}

			CloseHandle(hFile);
			delete pBuffer;
			// Encrypt and Decrypt Successfully;

			DWORD dwEnd = GetTickCount();

			DWORD dwTime = dwEnd - dwStart;
			dwTime = dwTime/1000+1;
			char szBuf[128];
			CString s;
			s.LoadString(IDS_SPARETIME);
			wsprintf(szBuf, s, dwTime);
			AfxMessageBox(szBuf);
			SKAPIClose();
			return;
		}
		else
		{
			// Decrypt data;
			BYTE byData[8];
			int iLen;
			BYTE *pText;
			DWORD dwBytes;

			HANDLE hFile = CreateFile(m_strSrcFile, GENERIC_READ,
						FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);

			if(hFile == INVALID_HANDLE_VALUE)
			{
				AfxMessageBox(IDS_OPENFILE);
				SKAPIClose();
				return;
			}
			DWORD dwOriginalSize;
			DWORD dwNewLen = GetFileSize(hFile, NULL);
			if(!ReadFile(hFile, &dwOriginalSize, 4, &dwBytes, NULL)
						|| dwBytes == 0)
			{
				AfxMessageBox(IDS_LOCKFAILED);
				SKAPIClose();
				CloseHandle(hFile);
				return;
			}
			BYTE* pBuffer = new BYTE[dwNewLen-4];
			iLen = dwNewLen-4;

			if(!ReadFile(hFile, pBuffer, iLen, &dwBytes, NULL)
						|| dwBytes == 0)
			{
				AfxMessageBox(IDS_LOCKFAILED);
				SKAPIClose();
				delete pBuffer;
				CloseHandle(hFile);
				return;
			}
			CloseHandle(hFile);

			UINT a,i;
			a = iLen/8;
			hFile = CreateFile(m_strDesFile, GENERIC_WRITE,
						0, NULL, CREATE_ALWAYS, 0, NULL);
			if(hFile == INVALID_HANDLE_VALUE)
			{
				AfxMessageBox(IDS_WRITEFILE);
				SKAPIClose();
				delete pBuffer;
				return;
			}

			pText = pBuffer;
			int iWriteLen = 0;
			for(i=0; i<a; i++)
			{
				memset(byData, 0, 8);
				memcpy((LPSTR)byData, pText, 8);
				if(!SKAPIDecrypt(byData))
				{
					AfxMessageBox(IDS_LOCKFAILED);
					SKAPIClose();
					delete pBuffer;
					CloseHandle(hFile);
					return;
				}
				if((i+1)*8>dwOriginalSize)
				{
					WriteFile(hFile, byData, dwOriginalSize-i*8, &dwBytes, NULL);
				}
				else
					WriteFile(hFile, byData, 8, &dwBytes, NULL);
				pText +=8;
			}

			CloseHandle(hFile);
			delete pBuffer;
			// Encrypt and Decrypt Successfully;

			DWORD dwEnd = GetTickCount();

			DWORD dwTime = dwEnd - dwStart;
			dwTime = (dwTime/1000)+1;
			char szBuf[128];
			CString s;
			s.LoadString(IDS_SPARETIME);
			wsprintf(szBuf, s, dwTime);
			AfxMessageBox(szBuf);
			SKAPIClose();
			return;
		}
	}
	AfxMessageBox(IDS_LOCKFAILED);
//	CDialog::OnOK();
}
#pragma optimize( "", on )


void CSKToolsDlg::OnBrowse() 
{
	// TODO: Add your control notification handler code here
	
	if(nLastControl != IDC_EDITDESFILE)
	{
		CFileDialog dlg(TRUE,"*",NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
						"All Files (*.*)|*.*||");
		if(dlg.DoModal() != IDOK)
			return;
		GetDlgItem(IDC_EDITSRCFILE)->SetWindowText(dlg.GetPathName());
	}
	else
	{
		CFileDialog dlg(TRUE,"*",NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
						"All Files (*.*)|*.*||");
		if(dlg.DoModal() != IDOK)
			return;
		GetDlgItem(IDC_EDITDESFILE)->SetWindowText(dlg.GetPathName());
	}
}


void CSKToolsDlg::OnControlSetFocus(UINT idControl)
{
	nLastControl = idControl;
}


HHOOK CSKToolsDlg::hhook = NULL;
LRESULT CALLBACK CSKToolsDlg::KeyboardProc(int code, WPARAM wParam, LPARAM lParam)
{
	if (code >= 0)
	{
		if ((long)lParam > 0)
		{
			if (GetKeyState(VK_CONTROL) < 0)
			{
				goto __CallDefault;
			}

			HWND hwnd = ::GetFocus();
			if (hwnd != NULL)
			{
				UINT nID = ::GetWindowID(hwnd);
/*				if (nID == IDC_EDITREADPWD)
				{
					if ((wParam >= 'A' && wParam <= 'F') || 
						(wParam >= '0' && wParam <= '9') ||
						(wParam >= VK_NUMPAD0 && wParam <= VK_NUMPAD9))
					{
						if (wParam >= '0' && wParam <= '9')
						{
							if (GetKeyState(VK_SHIFT) < 0)
							{
								return TRUE;
							}
						}
					}
					else
					{
						if (wParam == VK_BACK || wParam == VK_DELETE ||
							wParam == VK_LEFT || wParam == VK_RIGHT ||
							wParam == VK_UP || wParam == VK_DOWN ||
							wParam == VK_PRIOR || wParam == VK_NEXT ||
							wParam == VK_HOME || wParam == VK_END ||
							wParam == VK_ESCAPE || wParam == VK_RETURN ||
							wParam == VK_SHIFT || wParam == VK_CONTROL ||
							wParam == VK_CAPITAL || wParam == VK_INSERT ||
							wParam == VK_TAB)
						{
						}
						else
						{
							return TRUE;
						}
					}
				}*/
				/*else*/ if (nID == IDC_DEVELOPID)
				{
					if ((wParam >= 'A' && wParam <= 'F') || 
						(wParam >= '0' && wParam <= '9') ||
						(wParam >= VK_NUMPAD0 && wParam <= VK_NUMPAD9) ||
						wParam == 0xDB/*'{'*/ || wParam == 0xDD/*'}'*/ || wParam == 0xBD/*'-'*/)
					{
						if ((wParam >= '0' && wParam <= '9') || wParam == 0xBD)
						{
							if (GetKeyState(VK_SHIFT) < 0)
							{
								return TRUE;
							}
						}
						else if (wParam == 0xDB || wParam == 0xDD)
						{
							if (GetKeyState(VK_SHIFT) >= 0)
							{
								return TRUE;
							}
						}
					}
					else
					{
						if (wParam == VK_BACK || wParam == VK_DELETE ||
							wParam == VK_LEFT || wParam == VK_RIGHT ||
							wParam == VK_UP || wParam == VK_DOWN ||
							wParam == VK_PRIOR || wParam == VK_NEXT ||
							wParam == VK_HOME || wParam == VK_END ||
							wParam == VK_ESCAPE || wParam == VK_RETURN ||
							wParam == VK_SHIFT || wParam == VK_CONTROL ||
							wParam == VK_CAPITAL || wParam == VK_INSERT ||
							wParam == VK_TAB)
						{
						}
						else
						{
							return TRUE;
						}
					}
				}
			}
		}
	}

__CallDefault:
	return CallNextHookEx(hhook, code, wParam, lParam);
}

